function CholeskyOctaveGenerateTestData(n)
  
  A = generateSPDmatrix(n);
  
endfunction  

function B = generateSPDmatrix(n)

eigen_mean = 2; 
% can be made anything, even zero 
% used to shift the mode of the distribution

Q = rand(n,n);
B = Q' * diag(abs(eigen_mean+randn(n,1))) * Q;
C2 = chol(B);

%Geeksforgeeks (C/C++)
tic
mkdir('testdata_geeks');
fname = sprintf('testdata_geeks/testdata_geeks_%d.txt',n);
fid = fopen(fname, 'w+');
fprintf(fid, '{ ');
for i=1:size(B, 1)
  fprintf(fid, '{ ');
  for j=1:size(B, 2)
    fprintf(fid, '%i', B(i,j));
    if j<size(B, 2)
      fprintf(fid, ', ');
    end
  end
    fprintf(fid, '}');
    if i<size(B, 1)
      fprintf(fid, ',');
    end
    fprintf(fid, '\n');
end
fprintf(fid, ' };');
fclose(fid);
toc
%Rosetta (C/C++)
tic
mkdir('testdata_rossetaCpp');
fname = sprintf('testdata_rossetaCpp/testdata_rosettaCpp_%d.txt',n);
fid = fopen(fname, 'w+');
fprintf(fid, '{ ');
for i=1:size(B, 1)
  for j=1:size(B, 2)
    fprintf(fid, '%i', B(i,j));
    if j<size(B, 2)
      fprintf(fid, ', ');
    else
      if i<size(B, 1)
        fprintf(fid, ', ');
      end
    end
  end
    fprintf(fid, '\n');
end
fprintf(fid, ' };');
fclose(fid);
toc
%Rosetta (Python)
tic
mkdir('testdata_rossetaPython');
fname = sprintf('testdata_rossetaPython/testdata_rosettaPython_%d.txt',n);
fid = fopen(fname, 'w+');
fprintf(fid, '[ ');
for i=1:size(B, 1)
  fprintf(fid, '[ ');
  for j=1:size(B, 2)
    fprintf(fid, '%i', B(i,j));
    if j<size(B, 2)
      fprintf(fid, ', ');
    else
        fprintf(fid, ']');
      if i<size(B, 1)
        fprintf(fid, ', ');
      end
    end
  end
    fprintf(fid, '\n');
end
fprintf(fid, ' ]');
fclose(fid);
toc
%Rosetta (Java)
tic
mkdir('testdata_rossetaJava');
fname = sprintf('testdata_rossetaJava/testdata_rosettaJava_%d.txt',n);
fid = fopen(fname, 'w+');
for i=1:size(B, 1)
  for j=1:size(B, 2)
    fprintf(fid, '%i', B(i,j));
    if j<size(B, 2)
      fprintf(fid, ', ');
    else
      if i<size(B, 1)
        fprintf(fid, ', ');
      end
    end
  end
    fprintf(fid, '\n');
end
fclose(fid);
toc

%Octave (CSV)
tic;
mkdir('testdata_csv');
fname = sprintf('testdata_csv/testdata_%d.csv',n);
csvwrite(fname, B);
toc;

%Validation (if not success execute again till hermitic positive-defined matrix)
%If ok -> Clean last blank line
fname = sprintf('testdata_csv/testdata_%d.csv',n);
data = csvread(fname);
if B != data
  printf('NOT VALID DATA: missmatch of input matrixes (generated-fileread_csv)')
else
  matrixChol = chol(data)
end


endfunction